/* ***********************************************************
 * This file was automatically generated on 2024-02-27.      *
 *                                                           *
 * C# Bindings Version 2.1.32                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Communicates with CAN bus devices
	/// </summary>
	public class BrickletCANV2 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 2107;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "CAN Bricklet 2.0";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_WRITE_FRAME_LOW_LEVEL = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_READ_FRAME_LOW_LEVEL = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_FRAME_READ_CALLBACK_CONFIGURATION = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_FRAME_READ_CALLBACK_CONFIGURATION = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_TRANSCEIVER_CONFIGURATION = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TRANSCEIVER_CONFIGURATION = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_QUEUE_CONFIGURATION_LOW_LEVEL = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_QUEUE_CONFIGURATION_LOW_LEVEL = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_READ_FILTER_CONFIGURATION = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_READ_FILTER_CONFIGURATION = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ERROR_LOG_LOW_LEVEL = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_COMMUNICATION_LED_CONFIG = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_COMMUNICATION_LED_CONFIG = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ERROR_LED_CONFIG = 14;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ERROR_LED_CONFIG = 15;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION = 17;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION = 18;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ERROR_OCCURRED_CALLBACK_CONFIGURATION = 20;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ERROR_OCCURRED_CALLBACK_CONFIGURATION = 21;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SPITFP_ERROR_COUNT = 234;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_BOOTLOADER_MODE = 235;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_BOOTLOADER_MODE = 236;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_WRITE_FIRMWARE = 238;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_STATUS_LED_CONFIG = 239;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_STATUS_LED_CONFIG = 240;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CHIP_TEMPERATURE = 242;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_RESET = 243;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_WRITE_UID = 248;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_READ_UID = 249;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_FRAME_READ_LOW_LEVEL = 16;

		private const int CALLBACK_FRAME_READABLE = 19;

		private const int CALLBACK_ERROR_OCCURRED = 22;

		private const int CALLBACK_FRAME_READ = -16;


		/// <summary>
		/// </summary>
		public const byte FRAME_TYPE_STANDARD_DATA = 0;

		/// <summary>
		/// </summary>
		public const byte FRAME_TYPE_STANDARD_REMOTE = 1;

		/// <summary>
		/// </summary>
		public const byte FRAME_TYPE_EXTENDED_DATA = 2;

		/// <summary>
		/// </summary>
		public const byte FRAME_TYPE_EXTENDED_REMOTE = 3;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_MODE_NORMAL = 0;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_MODE_LOOPBACK = 1;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_MODE_READ_ONLY = 2;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_ACCEPT_ALL = 0;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_MATCH_STANDARD_ONLY = 1;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_MATCH_EXTENDED_ONLY = 2;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_MATCH_STANDARD_AND_EXTENDED = 3;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_STATE_ACTIVE = 0;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_STATE_PASSIVE = 1;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_STATE_DISABLED = 2;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_LED_CONFIG_OFF = 0;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_LED_CONFIG_ON = 1;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_LED_CONFIG_SHOW_HEARTBEAT = 2;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_LED_CONFIG_SHOW_COMMUNICATION = 3;

		/// <summary>
		/// </summary>
		public const byte ERROR_LED_CONFIG_OFF = 0;

		/// <summary>
		/// </summary>
		public const byte ERROR_LED_CONFIG_ON = 1;

		/// <summary>
		/// </summary>
		public const byte ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2;

		/// <summary>
		/// </summary>
		public const byte ERROR_LED_CONFIG_SHOW_TRANSCEIVER_STATE = 3;

		/// <summary>
		/// </summary>
		public const byte ERROR_LED_CONFIG_SHOW_ERROR = 4;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_MODE_BOOTLOADER = 0;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_MODE_FIRMWARE = 1;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_STATUS_OK = 0;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_STATUS_INVALID_MODE = 1;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_STATUS_NO_CHANGE = 2;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;

		/// <summary>
		/// </summary>
		public const byte BOOTLOADER_STATUS_CRC_MISMATCH = 5;

		/// <summary>
		/// </summary>
		public const byte STATUS_LED_CONFIG_OFF = 0;

		/// <summary>
		/// </summary>
		public const byte STATUS_LED_CONFIG_ON = 1;

		/// <summary>
		/// </summary>
		public const byte STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;

		/// <summary>
		/// </summary>
		public const byte STATUS_LED_CONFIG_SHOW_STATUS = 3;


		/// <summary>
		///  <see cref="Tinkerforge.BrickletCANV2.FrameReadCallback"/>
		/// </summary>
		public event FrameReadLowLevelEventHandler FrameReadLowLevelCallback;
		/// <summary>
		/// </summary>
		public delegate void FrameReadLowLevelEventHandler(BrickletCANV2 sender, byte frameType, long identifier, byte dataLength, byte[] dataData);

		/// <summary>
		///  This callback is triggered if a data or remote frame was received by the CAN
		///  transceiver. The received frame can be read with <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/>.
		///  If additional frames are received, but <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/> was not called yet, the callback
		///  will not trigger again.
		///  
		///  A configurable read filter can be used to define which frames should be
		///  received by the CAN transceiver and put into the read queue (see
		///  <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>).
		///  
		///  To enable this callback, use <see cref="Tinkerforge.BrickletCANV2.SetFrameReadableCallbackConfiguration"/>.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public event FrameReadableEventHandler FrameReadableCallback;
		/// <summary>
		/// </summary>
		public delegate void FrameReadableEventHandler(BrickletCANV2 sender);

		/// <summary>
		///  This callback is triggered if any error occurred while writing, reading or transmitting CAN frames.
		///  
		///  The callback is only triggered once until <see cref="Tinkerforge.BrickletCANV2.GetErrorLog"/> is called. That function will return
		///  details abount the error(s) occurred.
		///  
		///  To enable this callback, use <see cref="Tinkerforge.BrickletCANV2.SetErrorOccurredCallbackConfiguration"/>.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public event ErrorOccurredEventHandler ErrorOccurredCallback;
		/// <summary>
		/// </summary>
		public delegate void ErrorOccurredEventHandler(BrickletCANV2 sender);

		/// <summary>
		///  This callback is triggered if a data or remote frame was received by the CAN
		///  transceiver.
		///  
		///  The ``identifier`` return value follows the identifier format described for
		///  <see cref="Tinkerforge.BrickletCANV2.WriteFrame"/>.
		///  
		///  For details on the ``data`` return value see <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/>.
		///  
		///  A configurable read filter can be used to define which frames should be
		///  received by the CAN transceiver and put into the read queue (see
		///  <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>).
		///  
		///  To enable this callback, use <see cref="Tinkerforge.BrickletCANV2.SetFrameReadCallbackConfiguration"/>.
		///  
		///  <note>
		///   If reconstructing the value fails, the callback is triggered with null for data.
		///  </note>
		/// </summary>
		public event FrameReadEventHandler FrameReadCallback;
		/// <summary>
		/// </summary>
		public delegate void FrameReadEventHandler(BrickletCANV2 sender, byte frameType, long identifier, byte[] data);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletCANV2(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_FRAME_READ_LOW_LEVEL] = new CallbackWrapper(OnFrameReadLowLevelCallback);
			callbackWrappers[CALLBACK_FRAME_READABLE] = new CallbackWrapper(OnFrameReadableCallback);
			callbackWrappers[CALLBACK_ERROR_OCCURRED] = new CallbackWrapper(OnErrorOccurredCallback);

			highLevelCallbacks[-CALLBACK_FRAME_READ] = new HighLevelCallback();

			responseExpected[FUNCTION_WRITE_FRAME_LOW_LEVEL] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_READ_FRAME_LOW_LEVEL] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_FRAME_READ_CALLBACK_CONFIGURATION] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_FRAME_READ_CALLBACK_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TRANSCEIVER_CONFIGURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_TRANSCEIVER_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_QUEUE_CONFIGURATION_LOW_LEVEL] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_QUEUE_CONFIGURATION_LOW_LEVEL] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_READ_FILTER_CONFIGURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_READ_FILTER_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ERROR_LOG_LOW_LEVEL] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_COMMUNICATION_LED_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_COMMUNICATION_LED_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ERROR_LED_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_ERROR_LED_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ERROR_OCCURRED_CALLBACK_CONFIGURATION] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ERROR_OCCURRED_CALLBACK_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_SPITFP_ERROR_COUNT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_BOOTLOADER_MODE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_BOOTLOADER_MODE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_WRITE_FIRMWARE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_STATUS_LED_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_STATUS_LED_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_CHIP_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_RESET] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_WRITE_UID] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_READ_UID] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Writes a data or remote frame to the write queue to be transmitted over the
		///  CAN transceiver.
		///  
		///  The Bricklet supports the standard 11-bit (CAN 2.0A) and the additional extended
		///  29-bit (CAN 2.0B) identifiers. For standard frames the Bricklet uses bit 0 to 10
		///  from the ``identifier`` parameter as standard 11-bit identifier. For extended
		///  frames the Bricklet uses bit 0 to 28 from the ``identifier`` parameter as
		///  extended 29-bit identifier.
		///  
		///  The ``data`` parameter can be up to 15 bytes long. For data frames up to 8 bytes
		///  will be used as the actual data. The length (DLC) field in the data or remote
		///  frame will be set to the actual length of the ``data`` parameter. This allows
		///  to transmit data and remote frames with excess length. For remote frames only
		///  the length of the ``data`` parameter is used. The actual ``data`` bytes are
		///  ignored.
		///  
		///  Returns *true* if the frame was successfully added to the write queue. Returns
		///  *false* if the frame could not be added because write queue is already full or
		///  because the write buffer or the write backlog are configured with a size of
		///  zero (see <see cref="Tinkerforge.BrickletCANV2.SetQueueConfiguration"/>).
		///  
		///  The write queue can overflow if frames are written to it at a higher rate
		///  than the Bricklet can transmitted them over the CAN transceiver. This may
		///  happen if the CAN transceiver is configured as read-only or is using a low baud
		///  rate (see <see cref="Tinkerforge.BrickletCANV2.SetTransceiverConfiguration"/>). It can also happen if the CAN
		///  bus is congested and the frame cannot be transmitted because it constantly loses
		///  arbitration or because the CAN transceiver is currently disabled due to a high
		///  write error level (see <see cref="Tinkerforge.BrickletCANV2.GetErrorLog"/>).
		/// </summary>
		public bool WriteFrameLowLevel(byte frameType, long identifier, byte dataLength, byte[] dataData)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(29, FUNCTION_WRITE_FRAME_LOW_LEVEL);
			LEConverter.To((byte)frameType, 8, request);
			LEConverter.To((int)identifier, 9, request);
			LEConverter.To((byte)dataLength, 13, request);
			LEConverter.To((byte[])dataData, 14, 15, request);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Tries to read the next data or remote frame from the read queue and returns it.
		///  If a frame was successfully read, then the ``success`` return value is set to
		///  *true* and the other return values contain the frame. If the read queue is
		///  empty and no frame could be read, then the ``success`` return value is set to
		///  *false* and the other return values contain invalid data.
		///  
		///  The ``identifier`` return value follows the identifier format described for
		///  <see cref="Tinkerforge.BrickletCANV2.WriteFrame"/>.
		///  
		///  The ``data`` return value can be up to 15 bytes long. For data frames up to the
		///  first 8 bytes are the actual received data. All bytes after the 8th byte are
		///  always zero and only there to indicate the length of a data or remote frame
		///  with excess length. For remote frames the length of the ``data`` return value
		///  represents the requested length. The actual ``data`` bytes are always zero.
		///  
		///  A configurable read filter can be used to define which frames should be
		///  received by the CAN transceiver and put into the read queue (see
		///  <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>).
		///  
		///  Instead of polling with this function, you can also use callbacks. See the
		///  <see cref="Tinkerforge.BrickletCANV2.SetFrameReadCallbackConfiguration"/> function and the <see cref="Tinkerforge.BrickletCANV2.FrameReadCallback"/>
		///  callback.
		/// </summary>
		public void ReadFrameLowLevel(out bool success, out byte frameType, out long identifier, out byte dataLength, out byte[] dataData)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_READ_FRAME_LOW_LEVEL);

			byte[] response = SendRequest(request, 30);

			success = LEConverter.BoolFrom(8, response);
			frameType = LEConverter.ByteFrom(9, response);
			identifier = LEConverter.UIntFrom(10, response);
			dataLength = LEConverter.ByteFrom(14, response);
			dataData = LEConverter.ByteArrayFrom(15, response, 15);
		}

		/// <summary>
		///  Enables and disables the <see cref="Tinkerforge.BrickletCANV2.FrameReadCallback"/> callback.
		///  
		///  By default the callback is disabled. Enabling this callback will disable the <see cref="Tinkerforge.BrickletCANV2.FrameReadableCallback"/> callback.
		/// </summary>
		public void SetFrameReadCallbackConfiguration(bool enabled)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_FRAME_READ_CALLBACK_CONFIGURATION);
			LEConverter.To((bool)enabled, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if the <see cref="Tinkerforge.BrickletCANV2.FrameReadCallback"/> callback is enabled, *false* otherwise.
		/// </summary>
		public bool GetFrameReadCallbackConfiguration()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_FRAME_READ_CALLBACK_CONFIGURATION);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Sets the transceiver configuration for the CAN bus communication.
		///  
		///  The CAN transceiver has three different modes:
		///  
		///  * Normal: Reads from and writes to the CAN bus and performs active bus
		///    error detection and acknowledgement.
		///  * Loopback: All reads and writes are performed internally. The transceiver
		///    is disconnected from the actual CAN bus.
		///  * Read-Only: Only reads from the CAN bus, but does neither active bus error
		///    detection nor acknowledgement. Only the receiving part of the transceiver
		///    is connected to the CAN bus.
		/// </summary>
		public void SetTransceiverConfiguration(long baudRate, int samplePoint, byte transceiverMode)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(15, FUNCTION_SET_TRANSCEIVER_CONFIGURATION);
			LEConverter.To((int)baudRate, 8, request);
			LEConverter.To((short)samplePoint, 12, request);
			LEConverter.To((byte)transceiverMode, 14, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletCANV2.SetTransceiverConfiguration"/>.
		/// </summary>
		public void GetTransceiverConfiguration(out long baudRate, out int samplePoint, out byte transceiverMode)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TRANSCEIVER_CONFIGURATION);

			byte[] response = SendRequest(request, 15);

			baudRate = LEConverter.UIntFrom(8, response);
			samplePoint = LEConverter.UShortFrom(12, response);
			transceiverMode = LEConverter.ByteFrom(14, response);
		}

		/// <summary>
		///  Sets the write and read queue configuration.
		///  
		///  The CAN transceiver has 32 buffers in total in hardware for transmitting and
		///  receiving frames. Additionally, the Bricklet has a backlog for 768 frames in
		///  total in software. The buffers and the backlog can be freely assigned to the
		///  write and read queues.
		///  
		///  <see cref="Tinkerforge.BrickletCANV2.WriteFrame"/> writes a frame into the write backlog. The Bricklet moves
		///  the frame from the backlog into a free write buffer. The CAN transceiver then
		///  transmits the frame from the write buffer to the CAN bus. If there are no
		///  write buffers (``write_buffer_size`` is zero) or there is no write backlog
		///  (``write_backlog_size`` is zero) then no frames can be transmitted and
		///  <see cref="Tinkerforge.BrickletCANV2.WriteFrame"/> returns always *false*.
		///  
		///  The CAN transceiver receives a frame from the CAN bus and stores it into a
		///  free read buffer. The Bricklet moves the frame from the read buffer into the
		///  read backlog. <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/> reads the frame from the read backlog and
		///  returns it. If there are no read buffers (``read_buffer_sizes`` is empty) or
		///  there is no read backlog (``read_backlog_size`` is zero) then no frames can be
		///  received and <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/> returns always *false*.
		///  
		///  There can be multiple read buffers, because the CAN transceiver cannot receive
		///  data and remote frames into the same read buffer. A positive read buffer size
		///  represents a data frame read buffer and a negative read buffer size represents
		///  a remote frame read buffer. A read buffer size of zero is not allowed. By
		///  default the first read buffer is configured for data frames and the second read
		///  buffer is configured for remote frame. There can be up to 32 different read
		///  buffers, assuming that no write buffer is used. Each read buffer has its own
		///  filter configuration (see <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>).
		///  
		///  A valid queue configuration fulfills these conditions::
		///  
		///   write_buffer_size + abs(read_buffer_size_0) + abs(read_buffer_size_1) + ... + abs(read_buffer_size_31) &lt;= 32
		///   write_backlog_size + read_backlog_size &lt;= 768
		///  
		///  The write buffer timeout has three different modes that define how a failed
		///  frame transmission should be handled:
		///  
		///  * Single-Shot (&lt; 0): Only one transmission attempt will be made. If the
		///    transmission fails then the frame is discarded.
		///  * Infinite (= 0): Infinite transmission attempts will be made. The frame will
		///    never be discarded.
		///  * Milliseconds (&gt; 0): A limited number of transmission attempts will be made.
		///    If the frame could not be transmitted successfully after the configured
		///    number of milliseconds then the frame is discarded.
		///  
		///  The current content of the queues is lost when this function is called.
		/// </summary>
		public void SetQueueConfigurationLowLevel(byte writeBufferSize, int writeBufferTimeout, int writeBacklogSize, byte readBufferSizesLength, short[] readBufferSizesData, int readBacklogSize)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(50, FUNCTION_SET_QUEUE_CONFIGURATION_LOW_LEVEL);
			LEConverter.To((byte)writeBufferSize, 8, request);
			LEConverter.To((int)writeBufferTimeout, 9, request);
			LEConverter.To((short)writeBacklogSize, 13, request);
			LEConverter.To((byte)readBufferSizesLength, 15, request);
			byte[] _readBufferSizesData = new byte[32];
			for (int i = 0; i < 32; ++i) {
				_readBufferSizesData[i] = (byte)readBufferSizesData[i];
			}
			LEConverter.To(_readBufferSizesData, 16, 32, request);
			LEConverter.To((short)readBacklogSize, 48, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the queue configuration as set by <see cref="Tinkerforge.BrickletCANV2.SetQueueConfiguration"/>.
		/// </summary>
		public void GetQueueConfigurationLowLevel(out byte writeBufferSize, out int writeBufferTimeout, out int writeBacklogSize, out byte readBufferSizesLength, out short[] readBufferSizesData, out int readBacklogSize)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_QUEUE_CONFIGURATION_LOW_LEVEL);

			byte[] response = SendRequest(request, 50);

			writeBufferSize = LEConverter.ByteFrom(8, response);
			writeBufferTimeout = LEConverter.IntFrom(9, response);
			writeBacklogSize = LEConverter.UShortFrom(13, response);
			readBufferSizesLength = LEConverter.ByteFrom(15, response);
			readBufferSizesData = LEConverter.SByteArrayFrom(16, response, 32);
			readBacklogSize = LEConverter.UShortFrom(48, response);
		}

		/// <summary>
		///  Set the read filter configuration for the given read buffer index. This can be
		///  used to define which frames should be received by the CAN transceiver and put
		///  into the read buffer.
		///  
		///  The read filter has four different modes that define if and how the filter mask
		///  and the filter identifier are applied:
		///  
		///  * Accept-All: All frames are received.
		///  * Match-Standard-Only: Only standard frames with a matching identifier are
		///    received.
		///  * Match-Extended-Only: Only extended frames with a matching identifier are
		///    received.
		///  * Match-Standard-And-Extended: Standard and extended frames with a matching
		///    identifier are received.
		///  
		///  The filter mask and filter identifier are used as bit masks. Their usage
		///  depends on the mode:
		///  
		///  * Accept-All: Mask and identifier are ignored.
		///  * Match-Standard-Only: Bit 0 to 10 (11 bits) of filter mask and filter
		///    identifier are used to match the 11-bit identifier of standard frames.
		///  * Match-Extended-Only: Bit 0 to 28 (29 bits) of filter mask and filter
		///    identifier are used to match the 29-bit identifier of extended frames.
		///  * Match-Standard-And-Extended: Bit 18 to 28 (11 bits) of filter mask and filter
		///    identifier are used to match the 11-bit identifier of standard frames, bit 0
		///    to 17 (18 bits) are ignored in this case. Bit 0 to 28 (29 bits) of filter
		///    mask and filter identifier are used to match the 29-bit identifier of extended
		///    frames.
		///  
		///  The filter mask and filter identifier are applied in this way: The filter mask
		///  is used to select the frame identifier bits that should be compared to the
		///  corresponding filter identifier bits. All unselected bits are automatically
		///  accepted. All selected bits have to match the filter identifier to be accepted.
		///  If all bits for the selected mode are accepted then the frame is accepted and
		///  is added to the read buffer.
		///  
		///  <code>
		///   "Filter Mask Bit", "Filter Identifier Bit", "Frame Identifier Bit", "Result"
		///  
		///   0, X, X, Accept
		///   1, 0, 0, Accept
		///   1, 0, 1, Reject
		///   1, 1, 0, Reject
		///   1, 1, 1, Accept
		///  </code>
		///  
		///  For example, to receive standard frames with identifier 0x123 only, the mode
		///  can be set to Match-Standard-Only with 0x7FF as mask and 0x123 as identifier.
		///  The mask of 0x7FF selects all 11 identifier bits for matching so that the
		///  identifier has to be exactly 0x123 to be accepted.
		///  
		///  To accept identifier 0x123 and identifier 0x456 at the same time, just set
		///  filter 2 to 0x456 and keep mask and filter 1 unchanged.
		///  
		///  There can be up to 32 different read filters configured at the same time,
		///  because there can be up to 32 read buffer (see <see cref="Tinkerforge.BrickletCANV2.SetQueueConfiguration"/>).
		///  
		///  The default mode is accept-all for all read buffers.
		/// </summary>
		public void SetReadFilterConfiguration(byte bufferIndex, byte filterMode, long filterMask, long filterIdentifier)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(18, FUNCTION_SET_READ_FILTER_CONFIGURATION);
			LEConverter.To((byte)bufferIndex, 8, request);
			LEConverter.To((byte)filterMode, 9, request);
			LEConverter.To((int)filterMask, 10, request);
			LEConverter.To((int)filterIdentifier, 14, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the read filter configuration as set by <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>.
		/// </summary>
		public void GetReadFilterConfiguration(byte bufferIndex, out byte filterMode, out long filterMask, out long filterIdentifier)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_READ_FILTER_CONFIGURATION);
			LEConverter.To((byte)bufferIndex, 8, request);

			byte[] response = SendRequest(request, 17);

			filterMode = LEConverter.ByteFrom(8, response);
			filterMask = LEConverter.UIntFrom(9, response);
			filterIdentifier = LEConverter.UIntFrom(13, response);
		}

		/// <summary>
		///  Returns information about different kinds of errors.
		///  
		///  The write and read error levels indicate the current level of stuffing, form,
		///  acknowledgement, bit and checksum errors during CAN bus write and read
		///  operations. For each of this error kinds there is also an individual counter.
		///  
		///  When the write error level extends 255 then the CAN transceiver gets disabled
		///  and no frames can be transmitted or received anymore. The CAN transceiver will
		///  automatically be activated again after the CAN bus is idle for a while.
		///  
		///  The write buffer timeout, read buffer and backlog overflow counts represents the
		///  number of these errors:
		///  
		///  * A write buffer timeout occurs if a frame could not be transmitted before the
		///    configured write buffer timeout expired (see <see cref="Tinkerforge.BrickletCANV2.SetQueueConfiguration"/>).
		///  * A read buffer overflow occurs if a read buffer of the CAN transceiver
		///    still contains the last received frame when the next frame arrives. In this
		///    case the last received frame is lost. This happens if the CAN transceiver
		///    receives more frames than the Bricklet can handle. Using the read filter
		///    (see <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>) can help to reduce the amount of
		///    received frames. This count is not exact, but a lower bound, because the
		///    Bricklet might not able detect all overflows if they occur in rapid succession.
		///  * A read backlog overflow occurs if the read backlog of the Bricklet is already
		///    full when the next frame should be read from a read buffer of the CAN
		///    transceiver. In this case the frame in the read buffer is lost. This
		///    happens if the CAN transceiver receives more frames to be added to the read
		///    backlog than are removed from the read backlog using the <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/>
		///    function. Using the <see cref="Tinkerforge.BrickletCANV2.FrameReadCallback"/> callback ensures that the read backlog
		///    can not overflow.
		///  
		///  The read buffer overflow counter counts the overflows of all configured read
		///  buffers. Which read buffer exactly suffered from an overflow can be figured
		///  out from the read buffer overflow occurrence list
		///  (``read_buffer_overflow_error_occurred``). Reading the error log clears the
		///  occurence list.
		/// </summary>
		public void GetErrorLogLowLevel(out byte transceiverState, out byte transceiverWriteErrorLevel, out byte transceiverReadErrorLevel, out long transceiverStuffingErrorCount, out long transceiverFormatErrorCount, out long transceiverACKErrorCount, out long transceiverBit1ErrorCount, out long transceiverBit0ErrorCount, out long transceiverCRCErrorCount, out long writeBufferTimeoutErrorCount, out long readBufferOverflowErrorCount, out byte readBufferOverflowErrorOccurredLength, out bool[] readBufferOverflowErrorOccurredData, out long readBacklogOverflowErrorCount)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ERROR_LOG_LOW_LEVEL);

			byte[] response = SendRequest(request, 52);

			transceiverState = LEConverter.ByteFrom(8, response);
			transceiverWriteErrorLevel = LEConverter.ByteFrom(9, response);
			transceiverReadErrorLevel = LEConverter.ByteFrom(10, response);
			transceiverStuffingErrorCount = LEConverter.UIntFrom(11, response);
			transceiverFormatErrorCount = LEConverter.UIntFrom(15, response);
			transceiverACKErrorCount = LEConverter.UIntFrom(19, response);
			transceiverBit1ErrorCount = LEConverter.UIntFrom(23, response);
			transceiverBit0ErrorCount = LEConverter.UIntFrom(27, response);
			transceiverCRCErrorCount = LEConverter.UIntFrom(31, response);
			writeBufferTimeoutErrorCount = LEConverter.UIntFrom(35, response);
			readBufferOverflowErrorCount = LEConverter.UIntFrom(39, response);
			readBufferOverflowErrorOccurredLength = LEConverter.ByteFrom(43, response);
			byte[] readBufferOverflowErrorOccurredDataBits = new byte[4];
			readBufferOverflowErrorOccurredData = new bool[32];
			readBufferOverflowErrorOccurredDataBits = LEConverter.ByteArrayFrom(44, response, 4);
			for (int i = 0; i < 32; i++) {
				readBufferOverflowErrorOccurredData[i] = (readBufferOverflowErrorOccurredDataBits[i / 8] & (1 << (i % 8))) != 0;
			}
			readBacklogOverflowErrorCount = LEConverter.UIntFrom(48, response);
		}

		/// <summary>
		///  Sets the communication LED configuration. By default the LED shows
		///  CAN-Bus traffic, it flickers once for every 40 transmitted or received frames.
		///  
		///  You can also turn the LED permanently on/off or show a heartbeat.
		///  
		///  If the Bricklet is in bootloader mode, the LED is off.
		/// </summary>
		public void SetCommunicationLEDConfig(byte config)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_COMMUNICATION_LED_CONFIG);
			LEConverter.To((byte)config, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletCANV2.SetCommunicationLEDConfig"/>
		/// </summary>
		public byte GetCommunicationLEDConfig()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_COMMUNICATION_LED_CONFIG);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets the error LED configuration.
		///  
		///  By default (show-transceiver-state) the error LED turns on if the CAN
		///  transceiver is passive or disabled state (see <see cref="Tinkerforge.BrickletCANV2.GetErrorLog"/>). If
		///  the CAN transceiver is in active state the LED turns off.
		///  
		///  If the LED is configured as show-error then the error LED turns on if any error
		///  occurs. If you call this function with the show-error option again, the LED will
		///  turn off until the next error occurs.
		///  
		///  You can also turn the LED permanently on/off or show a heartbeat.
		///  
		///  If the Bricklet is in bootloader mode, the LED is off.
		/// </summary>
		public void SetErrorLEDConfig(byte config)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_ERROR_LED_CONFIG);
			LEConverter.To((byte)config, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletCANV2.SetErrorLEDConfig"/>.
		/// </summary>
		public byte GetErrorLEDConfig()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ERROR_LED_CONFIG);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Enables and disables the <see cref="Tinkerforge.BrickletCANV2.FrameReadableCallback"/> callback.
		///  
		///  By default the callback is disabled. Enabling this callback will disable the <see cref="Tinkerforge.BrickletCANV2.FrameReadCallback"/> callback.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public void SetFrameReadableCallbackConfiguration(bool enabled)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION);
			LEConverter.To((bool)enabled, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if the <see cref="Tinkerforge.BrickletCANV2.FrameReadableCallback"/> callback is enabled, *false* otherwise.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public bool GetFrameReadableCallbackConfiguration()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Enables and disables the <see cref="Tinkerforge.BrickletCANV2.ErrorOccurredCallback"/> callback.
		///  
		///  By default the callback is disabled.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public void SetErrorOccurredCallbackConfiguration(bool enabled)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_ERROR_OCCURRED_CALLBACK_CONFIGURATION);
			LEConverter.To((bool)enabled, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if the <see cref="Tinkerforge.BrickletCANV2.ErrorOccurredCallback"/> callback is enabled, *false* otherwise.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public bool GetErrorOccurredCallbackConfiguration()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ERROR_OCCURRED_CALLBACK_CONFIGURATION);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the error count for the communication between Brick and Bricklet.
		///  
		///  The errors are divided into
		///  
		///  * ACK checksum errors,
		///  * message checksum errors,
		///  * framing errors and
		///  * overflow errors.
		///  
		///  The errors counts are for errors that occur on the Bricklet side. All
		///  Bricks have a similar function that returns the errors on the Brick side.
		/// </summary>
		public void GetSPITFPErrorCount(out long errorCountAckChecksum, out long errorCountMessageChecksum, out long errorCountFrame, out long errorCountOverflow)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SPITFP_ERROR_COUNT);

			byte[] response = SendRequest(request, 24);

			errorCountAckChecksum = LEConverter.UIntFrom(8, response);
			errorCountMessageChecksum = LEConverter.UIntFrom(12, response);
			errorCountFrame = LEConverter.UIntFrom(16, response);
			errorCountOverflow = LEConverter.UIntFrom(20, response);
		}

		/// <summary>
		///  Sets the bootloader mode and returns the status after the requested
		///  mode change was instigated.
		///  
		///  You can change from bootloader mode to firmware mode and vice versa. A change
		///  from bootloader mode to firmware mode will only take place if the entry function,
		///  device identifier and CRC are present and correct.
		///  
		///  This function is used by Brick Viewer during flashing. It should not be
		///  necessary to call it in a normal user program.
		/// </summary>
		public byte SetBootloaderMode(byte mode)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_BOOTLOADER_MODE);
			LEConverter.To((byte)mode, 8, request);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the current bootloader mode, see <see cref="Tinkerforge.BrickletCANV2.SetBootloaderMode"/>.
		/// </summary>
		public byte GetBootloaderMode()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_BOOTLOADER_MODE);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets the firmware pointer for <see cref="Tinkerforge.BrickletCANV2.WriteFirmware"/>. The pointer has
		///  to be increased by chunks of size 64. The data is written to flash
		///  every 4 chunks (which equals to one page of size 256).
		///  
		///  This function is used by Brick Viewer during flashing. It should not be
		///  necessary to call it in a normal user program.
		/// </summary>
		public void SetWriteFirmwarePointer(long pointer)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_WRITE_FIRMWARE_POINTER);
			LEConverter.To((int)pointer, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Writes 64 Bytes of firmware at the position as written by
		///  <see cref="Tinkerforge.BrickletCANV2.SetWriteFirmwarePointer"/> before. The firmware is written
		///  to flash every 4 chunks.
		///  
		///  You can only write firmware in bootloader mode.
		///  
		///  This function is used by Brick Viewer during flashing. It should not be
		///  necessary to call it in a normal user program.
		/// </summary>
		public byte WriteFirmware(byte[] data)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(72, FUNCTION_WRITE_FIRMWARE);
			LEConverter.To((byte[])data, 8, 64, request);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets the status LED configuration. By default the LED shows
		///  communication traffic between Brick and Bricklet, it flickers once
		///  for every 10 received data packets.
		///  
		///  You can also turn the LED permanently on/off or show a heartbeat.
		///  
		///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
		/// </summary>
		public void SetStatusLEDConfig(byte config)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_STATUS_LED_CONFIG);
			LEConverter.To((byte)config, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletCANV2.SetStatusLEDConfig"/>
		/// </summary>
		public byte GetStatusLEDConfig()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_STATUS_LED_CONFIG);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the temperature as measured inside the microcontroller. The
		///  value returned is not the ambient temperature!
		///  
		///  The temperature is only proportional to the real temperature and it has bad
		///  accuracy. Practically it is only useful as an indicator for
		///  temperature changes.
		/// </summary>
		public short GetChipTemperature()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CHIP_TEMPERATURE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.ShortFrom(8, response);
		}

		/// <summary>
		///  Calling this function will reset the Bricklet. All configurations
		///  will be lost.
		///  
		///  After a reset you have to create new device objects,
		///  calling functions on the existing ones will result in
		///  undefined behavior!
		/// </summary>
		public void Reset()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_RESET);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Writes a new UID into flash. If you want to set a new UID
		///  you have to decode the Base58 encoded UID string into an
		///  integer first.
		///  
		///  We recommend that you use Brick Viewer to change the UID.
		/// </summary>
		public void WriteUID(long uid)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_WRITE_UID);
			LEConverter.To((int)uid, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the current UID as an integer. Encode as
		///  Base58 to get the usual string version.
		/// </summary>
		public long ReadUID()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_READ_UID);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		///  Writes a data or remote frame to the write queue to be transmitted over the
		///  CAN transceiver.
		///  
		///  The Bricklet supports the standard 11-bit (CAN 2.0A) and the additional extended
		///  29-bit (CAN 2.0B) identifiers. For standard frames the Bricklet uses bit 0 to 10
		///  from the ``identifier`` parameter as standard 11-bit identifier. For extended
		///  frames the Bricklet uses bit 0 to 28 from the ``identifier`` parameter as
		///  extended 29-bit identifier.
		///  
		///  The ``data`` parameter can be up to 15 bytes long. For data frames up to 8 bytes
		///  will be used as the actual data. The length (DLC) field in the data or remote
		///  frame will be set to the actual length of the ``data`` parameter. This allows
		///  to transmit data and remote frames with excess length. For remote frames only
		///  the length of the ``data`` parameter is used. The actual ``data`` bytes are
		///  ignored.
		///  
		///  Returns *true* if the frame was successfully added to the write queue. Returns
		///  *false* if the frame could not be added because write queue is already full or
		///  because the write buffer or the write backlog are configured with a size of
		///  zero (see <see cref="Tinkerforge.BrickletCANV2.SetQueueConfiguration"/>).
		///  
		///  The write queue can overflow if frames are written to it at a higher rate
		///  than the Bricklet can transmitted them over the CAN transceiver. This may
		///  happen if the CAN transceiver is configured as read-only or is using a low baud
		///  rate (see <see cref="Tinkerforge.BrickletCANV2.SetTransceiverConfiguration"/>). It can also happen if the CAN
		///  bus is congested and the frame cannot be transmitted because it constantly loses
		///  arbitration or because the CAN transceiver is currently disabled due to a high
		///  write error level (see <see cref="Tinkerforge.BrickletCANV2.GetErrorLog"/>).
		/// </summary>
		public bool WriteFrame(byte frameType, long identifier, byte[] data)
		{
			if (data.Length > 15)
			{
				throw new ArgumentException("Data can be at most 15 items long");
			}

			byte dataLength = (byte)data.Length;
			byte[] dataData = new byte[15];

			Array.Copy(data, dataData, dataLength);
			Array.Clear(dataData, dataLength, 15 - dataLength);

			return WriteFrameLowLevel(frameType, identifier, dataLength, dataData);
		}

		/// <summary>
		///  Tries to read the next data or remote frame from the read queue and returns it.
		///  If a frame was successfully read, then the ``success`` return value is set to
		///  *true* and the other return values contain the frame. If the read queue is
		///  empty and no frame could be read, then the ``success`` return value is set to
		///  *false* and the other return values contain invalid data.
		///  
		///  The ``identifier`` return value follows the identifier format described for
		///  <see cref="Tinkerforge.BrickletCANV2.WriteFrame"/>.
		///  
		///  The ``data`` return value can be up to 15 bytes long. For data frames up to the
		///  first 8 bytes are the actual received data. All bytes after the 8th byte are
		///  always zero and only there to indicate the length of a data or remote frame
		///  with excess length. For remote frames the length of the ``data`` return value
		///  represents the requested length. The actual ``data`` bytes are always zero.
		///  
		///  A configurable read filter can be used to define which frames should be
		///  received by the CAN transceiver and put into the read queue (see
		///  <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>).
		///  
		///  Instead of polling with this function, you can also use callbacks. See the
		///  <see cref="Tinkerforge.BrickletCANV2.SetFrameReadCallbackConfiguration"/> function and the <see cref="Tinkerforge.BrickletCANV2.FrameReadCallback"/>
		///  callback.
		/// </summary>
		public void ReadFrame(out bool success, out byte frameType, out long identifier, out byte[] data)
		{
			byte dataLength;
			byte[] dataData = new byte[15];

			ReadFrameLowLevel(out success, out frameType, out identifier, out dataLength, out dataData);

			data = new byte[dataLength];

			Array.Copy(dataData, data, dataLength);
		}

		/// <summary>
		///  Sets the write and read queue configuration.
		///  
		///  The CAN transceiver has 32 buffers in total in hardware for transmitting and
		///  receiving frames. Additionally, the Bricklet has a backlog for 768 frames in
		///  total in software. The buffers and the backlog can be freely assigned to the
		///  write and read queues.
		///  
		///  <see cref="Tinkerforge.BrickletCANV2.WriteFrame"/> writes a frame into the write backlog. The Bricklet moves
		///  the frame from the backlog into a free write buffer. The CAN transceiver then
		///  transmits the frame from the write buffer to the CAN bus. If there are no
		///  write buffers (``write_buffer_size`` is zero) or there is no write backlog
		///  (``write_backlog_size`` is zero) then no frames can be transmitted and
		///  <see cref="Tinkerforge.BrickletCANV2.WriteFrame"/> returns always *false*.
		///  
		///  The CAN transceiver receives a frame from the CAN bus and stores it into a
		///  free read buffer. The Bricklet moves the frame from the read buffer into the
		///  read backlog. <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/> reads the frame from the read backlog and
		///  returns it. If there are no read buffers (``read_buffer_sizes`` is empty) or
		///  there is no read backlog (``read_backlog_size`` is zero) then no frames can be
		///  received and <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/> returns always *false*.
		///  
		///  There can be multiple read buffers, because the CAN transceiver cannot receive
		///  data and remote frames into the same read buffer. A positive read buffer size
		///  represents a data frame read buffer and a negative read buffer size represents
		///  a remote frame read buffer. A read buffer size of zero is not allowed. By
		///  default the first read buffer is configured for data frames and the second read
		///  buffer is configured for remote frame. There can be up to 32 different read
		///  buffers, assuming that no write buffer is used. Each read buffer has its own
		///  filter configuration (see <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>).
		///  
		///  A valid queue configuration fulfills these conditions::
		///  
		///   write_buffer_size + abs(read_buffer_size_0) + abs(read_buffer_size_1) + ... + abs(read_buffer_size_31) &lt;= 32
		///   write_backlog_size + read_backlog_size &lt;= 768
		///  
		///  The write buffer timeout has three different modes that define how a failed
		///  frame transmission should be handled:
		///  
		///  * Single-Shot (&lt; 0): Only one transmission attempt will be made. If the
		///    transmission fails then the frame is discarded.
		///  * Infinite (= 0): Infinite transmission attempts will be made. The frame will
		///    never be discarded.
		///  * Milliseconds (&gt; 0): A limited number of transmission attempts will be made.
		///    If the frame could not be transmitted successfully after the configured
		///    number of milliseconds then the frame is discarded.
		///  
		///  The current content of the queues is lost when this function is called.
		/// </summary>
		public void SetQueueConfiguration(byte writeBufferSize, int writeBufferTimeout, int writeBacklogSize, short[] readBufferSizes, int readBacklogSize)
		{
			if (readBufferSizes.Length > 32)
			{
				throw new ArgumentException("Read Buffer Sizes can be at most 32 items long");
			}

			byte readBufferSizesLength = (byte)readBufferSizes.Length;
			short[] readBufferSizesData = new short[32];

			Array.Copy(readBufferSizes, readBufferSizesData, readBufferSizesLength);
			Array.Clear(readBufferSizesData, readBufferSizesLength, 32 - readBufferSizesLength);

			SetQueueConfigurationLowLevel(writeBufferSize, writeBufferTimeout, writeBacklogSize, readBufferSizesLength, readBufferSizesData, readBacklogSize);
		}

		/// <summary>
		///  Returns the queue configuration as set by <see cref="Tinkerforge.BrickletCANV2.SetQueueConfiguration"/>.
		/// </summary>
		public void GetQueueConfiguration(out byte writeBufferSize, out int writeBufferTimeout, out int writeBacklogSize, out short[] readBufferSizes, out int readBacklogSize)
		{
			byte readBufferSizesLength;
			short[] readBufferSizesData = new short[32];

			GetQueueConfigurationLowLevel(out writeBufferSize, out writeBufferTimeout, out writeBacklogSize, out readBufferSizesLength, out readBufferSizesData, out readBacklogSize);

			readBufferSizes = new short[readBufferSizesLength];

			Array.Copy(readBufferSizesData, readBufferSizes, readBufferSizesLength);
		}

		/// <summary>
		///  Returns information about different kinds of errors.
		///  
		///  The write and read error levels indicate the current level of stuffing, form,
		///  acknowledgement, bit and checksum errors during CAN bus write and read
		///  operations. For each of this error kinds there is also an individual counter.
		///  
		///  When the write error level extends 255 then the CAN transceiver gets disabled
		///  and no frames can be transmitted or received anymore. The CAN transceiver will
		///  automatically be activated again after the CAN bus is idle for a while.
		///  
		///  The write buffer timeout, read buffer and backlog overflow counts represents the
		///  number of these errors:
		///  
		///  * A write buffer timeout occurs if a frame could not be transmitted before the
		///    configured write buffer timeout expired (see <see cref="Tinkerforge.BrickletCANV2.SetQueueConfiguration"/>).
		///  * A read buffer overflow occurs if a read buffer of the CAN transceiver
		///    still contains the last received frame when the next frame arrives. In this
		///    case the last received frame is lost. This happens if the CAN transceiver
		///    receives more frames than the Bricklet can handle. Using the read filter
		///    (see <see cref="Tinkerforge.BrickletCANV2.SetReadFilterConfiguration"/>) can help to reduce the amount of
		///    received frames. This count is not exact, but a lower bound, because the
		///    Bricklet might not able detect all overflows if they occur in rapid succession.
		///  * A read backlog overflow occurs if the read backlog of the Bricklet is already
		///    full when the next frame should be read from a read buffer of the CAN
		///    transceiver. In this case the frame in the read buffer is lost. This
		///    happens if the CAN transceiver receives more frames to be added to the read
		///    backlog than are removed from the read backlog using the <see cref="Tinkerforge.BrickletCANV2.ReadFrame"/>
		///    function. Using the <see cref="Tinkerforge.BrickletCANV2.FrameReadCallback"/> callback ensures that the read backlog
		///    can not overflow.
		///  
		///  The read buffer overflow counter counts the overflows of all configured read
		///  buffers. Which read buffer exactly suffered from an overflow can be figured
		///  out from the read buffer overflow occurrence list
		///  (``read_buffer_overflow_error_occurred``). Reading the error log clears the
		///  occurence list.
		/// </summary>
		public void GetErrorLog(out byte transceiverState, out byte transceiverWriteErrorLevel, out byte transceiverReadErrorLevel, out long transceiverStuffingErrorCount, out long transceiverFormatErrorCount, out long transceiverACKErrorCount, out long transceiverBit1ErrorCount, out long transceiverBit0ErrorCount, out long transceiverCRCErrorCount, out long writeBufferTimeoutErrorCount, out long readBufferOverflowErrorCount, out bool[] readBufferOverflowErrorOccurred, out long readBacklogOverflowErrorCount)
		{
			byte readBufferOverflowErrorOccurredLength;
			bool[] readBufferOverflowErrorOccurredData = new bool[32];

			GetErrorLogLowLevel(out transceiverState, out transceiverWriteErrorLevel, out transceiverReadErrorLevel, out transceiverStuffingErrorCount, out transceiverFormatErrorCount, out transceiverACKErrorCount, out transceiverBit1ErrorCount, out transceiverBit0ErrorCount, out transceiverCRCErrorCount, out writeBufferTimeoutErrorCount, out readBufferOverflowErrorCount, out readBufferOverflowErrorOccurredLength, out readBufferOverflowErrorOccurredData, out readBacklogOverflowErrorCount);

			readBufferOverflowErrorOccurred = new bool[readBufferOverflowErrorOccurredLength];

			Array.Copy(readBufferOverflowErrorOccurredData, readBufferOverflowErrorOccurred, readBufferOverflowErrorOccurredLength);
		}

		/// <summary>
		/// </summary>
		protected void OnFrameReadLowLevelCallback(byte[] response)
		{
			if (response.Length != 29)
			{
				return; // silently ignoring callback with wrong length
			}

			byte frameType = LEConverter.ByteFrom(8, response);
			long identifier = LEConverter.UIntFrom(9, response);
			byte dataLength = LEConverter.ByteFrom(13, response);
			byte[] dataData = LEConverter.ByteArrayFrom(14, response, 15);
			var highLevelHandler = FrameReadCallback;

			if (highLevelHandler != null)
			{
				byte[] data = new byte[dataLength];

				Array.Copy(dataData, data, dataLength);

				highLevelHandler(this, frameType, identifier, data);
			}

			var handler = FrameReadLowLevelCallback;

			if (handler != null)
			{
				handler(this, frameType, identifier, dataLength, dataData);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnFrameReadableCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = FrameReadableCallback;

			if (handler != null)
			{
				handler(this);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnErrorOccurredCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = ErrorOccurredCallback;

			if (handler != null)
			{
				handler(this);
			}
		}
	}
}
